package fw.faces;

import java.io.CharArrayWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Enumeration;
import java.util.HashMap;
import java.util.Hashtable;
import java.util.Map;

import javax.servlet.Filter;
import javax.servlet.FilterChain;
import javax.servlet.FilterConfig;
import javax.servlet.RequestDispatcher;
import javax.servlet.ServletContext;
import javax.servlet.ServletException;
import javax.servlet.ServletRequest;
import javax.servlet.ServletResponse;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import javax.servlet.jsp.PageContext;

import fw.taglib.UIComponent;

public abstract class AbstractFilter implements Filter, INavigateListener {

	protected Hashtable <String, fwSessionContainer> activeSession = new Hashtable<String, fwSessionContainer>();

	protected abstract void PostProcesPeticio(ServletRequest request,
			ServletResponse response, fwSessionContainer objfwSessionContainer)
			throws IOException, ServletException;

	protected abstract void PreProcesPeticio(ServletRequest request,
			ServletResponse response, fwSessionContainer objfwSessionContainer)
			throws IOException, ServletException;

	protected abstract void ProcessAction(ServletRequest request,
			ServletResponse response, fwSessionContainer objfwSessionContainer)
			throws IOException, ServletException;

	private FilterConfig filterConfig = null;

	/**
	 * A typical implementation of this method would follow the following
	 * pattern:- 1. Examine the request 2. Optionally wrap the request object
	 * with a custom implementation to filter content or headers for input
	 * filtering 3. Optionally wrap the response object with a custom
	 * implementation to filter content or headers for output filtering 4. a)
	 * Either invoke the next entity in the chain using the FilterChain object
	 * (chain.doFilter()), 4. b) or not pass on the request/response pair to the
	 * next entity in the filter chain to block the request processing 5.
	 * Directly set headers on the response after invocation of the next entity
	 * in the filter chain. 
	 */
	public void doFilter(ServletRequest request, ServletResponse response,
			FilterChain chain) throws IOException, ServletException {

		HttpServletRequest httpRequest = (HttpServletRequest) request;
		HttpServletResponse httpResponse = (HttpServletResponse) response;
		fwSessionContainer objfwSessionContainer = (fwSessionContainer) httpRequest.getSession().getAttribute(fwSessionContainer.C_SESSION_CONTAINER);
		String nextPage="";
		
		
		synchronized (nextPage){
		
			
		// determinem el formulari que renderitzem
		nextPage = httpRequest.getParameter("fwidForm");
		if (nextPage == null) {
			String strUri = httpRequest.getRequestURI();
			nextPage = httpRequest.getRequestURI().substring(strUri.indexOf("ServletFacade/") + "ServletFacade/".length() - 1);
		}

		objfwSessionContainer=getSessionContainer(httpRequest.getSession().getId());
		if (objfwSessionContainer != null) {
			objfwSessionContainer.setCurrentAction(httpRequest.getParameter("fwdoaction"));
			objfwSessionContainer.setCurrentActionIdObject(httpRequest.getParameter("fwIdActionObject"));
			objfwSessionContainer.setCurrentHttpRequest(httpRequest);
			objfwSessionContainer.setCurrentHttpResponse(httpResponse);
			
		
			// Si la pagina de petici es la ultima que es va servir, es un postBack
			if (nextPage.equals(objfwSessionContainer.getNextPage()))
				objfwSessionContainer.getCurrentFormWrapper().getFormulariClass().setPostBack(true);
		}
		
		// si la petici es d'una sessio no existen la registrem
		if (!existsSession(httpRequest)) {
			objfwSessionContainer = addSessionContainer(httpRequest);
			// si la petici no conte el idformula petici
			objfwSessionContainer.setNextPage(objfwSessionContainer.getWelcomPage());
		} else {
			if (nextPage != null && nextPage != "")
				objfwSessionContainer.setNextPage(nextPage);
		}

		if (objfwSessionContainer.getNextPage().endsWith(".jsp")) {
			try {

				doInitForm(httpRequest, httpResponse, objfwSessionContainer, objfwSessionContainer.getNextPage());

			} catch (IOException e) {
				throw e;
			} catch (ServletException e) {
				throw e;
			} catch (Exception e) {
				throw new ServletException(e.getMessage());
			}

			try {
				if (objfwSessionContainer.getCurrentAction() != null)
					ProcessAction(request, response, objfwSessionContainer);
				if (objfwSessionContainer.isDoNavigation()){
					objfwSessionContainer.setDoNavigation(false);
					return; // Si em navegat no continuem amb l'actual chain
				}
			} catch (Throwable e) {
				System.out.println("ERROR: " + e.getMessage());
				throw e;
			}

			PrintWriter out = response.getWriter();
			CharResponseWrapper wrapper = new CharResponseWrapper((HttpServletResponse) response);

			
			chain.doFilter(request, wrapper);


			if (wrapper.getContentType().equals("text/html")) {
				CharArrayWriter caw = new CharArrayWriter();
				objfwSessionContainer.setDoNavigation(false);
				
				if (wrapper.toString().indexOf("<body>")!=-1){//pot ser un frameset
					caw.write(wrapper.toString().substring(0,
							wrapper.toString().indexOf("<body>") - 1));
	
					caw.write("<script>\n");
					caw.write("function sendAction(action,sender){\n");
					caw.write("  document.all.fwdoaction.value=action;\n");
					caw.write("  document.all.fwIdActionObject.value=sender.name;\n");
					caw.write("  document.all.fwGeneralform.submit();\n");
					caw.write("}\n");
					caw.write("</script>\n");
					caw.write("<body>\n");
					
					if(objfwSessionContainer.isbMessage()){
						caw.write(DivMessage(objfwSessionContainer.getUserMessage()));
					}
					caw.write("<form id=\"fwGeneralform\" name=\"fwGeneralform\" action=\"\" method=\"POST\">\n");
					caw.write("<input type=\"hidden\" id=\"fwdoaction\"  name=\"fwdoaction\">\n");
					caw.write("<input type=\"hidden\" id=\"fwidForm\"  name=\"fwidForm\" value=\""
							+ objfwSessionContainer.getNextPage() + "\">\n");
					caw.write("<input type=\"hidden\" id=\"fwIdActionObject\"  name=\"fwIdActionObject\" >\n");
					caw.write(wrapper.toString().substring( 
							wrapper.toString().indexOf("<body>") + 6,
							wrapper.toString().indexOf("</body>") - 1));
					caw.write("\n</form>\n</body></html>");
					response.setContentLength(caw.toString().length());
					out.write(caw.toString());
					objfwSessionContainer.setbMessage(false);
				}else{
					out.write(wrapper.toString());
				}
				
			} else
				out.write(wrapper.toString());

			out.close();

			try {
				PostProcesPeticio(request, response, objfwSessionContainer);
			} catch (Throwable ex) {
				System.out.println("ERROR: " + ex.getMessage());
				throw ex;
			}
			
		} else {
			
			chain.doFilter(request, response);
		}
		}
	}

	private void doInitForm(HttpServletRequest httpRequest,
			HttpServletResponse httpResponse,
			fwSessionContainer objfwSessionContainer, String nextPage)
			throws IOException, ServletException {

		try {
			// Si no existix el formulari obliquem a que es carregui
			if (!objfwSessionContainer.getStackForms().existsForm(nextPage))
				loadForm(httpRequest, httpResponse, nextPage, objfwSessionContainer);

			// si es un postBack carregem els objectes del request
			if (objfwSessionContainer.getCurrentFormWrapper().getFormulariClass().isPostBack())
				objfwSessionContainer.getCurrentFormWrapper().procesPostback(httpRequest);

			PreProcesPeticio(httpRequest, httpResponse, objfwSessionContainer);
		} catch (IOException e) {
			throw e;
		} catch (ServletException e) {
			throw e;
		} catch (Exception e) {
			e.printStackTrace();
			throw new ServletException(e.getMessage());
		}

	}
	private boolean isJSPage(HttpServletRequest httpRequest){
		return httpRequest.getRequestURI().endsWith(".jsp") || httpRequest.getRequestURI().endsWith("/");
		
	}
	@Override
	public void init(FilterConfig fc) throws ServletException {
		this.filterConfig = filterConfig;

	}

	@Override
	public void destroy() {
		this.filterConfig = null;
	}

	
	  protected fwSessionContainer getSessionContainer(String sessionID) { 
		  return  activeSession.get(sessionID); 
	  }

	protected fwSessionContainer addSessionContainer(HttpServletRequest request) {
		// s'inicia sessi la registrem
		HttpSession session = request.getSession();
		if (session.isNew()) {
			// busquem la pagina d'inici
			String[] objPages = (String[]) session.getServletContext().getAttribute("org.apache.catalina.WELCOME_FILES");
			String WelcomPage = "/" + objPages[0];
			// creem i inicialitzem el contenidor de variables
			fwSessionContainer objfwSessionContainer = new fwSessionContainer();
			objfwSessionContainer.setWelcomPage(WelcomPage);
			stackForms objStackForms = new stackForms();
			objfwSessionContainer.setStackForms(objStackForms);
			activeSession.put(session.getId(), objfwSessionContainer);
			session.setAttribute(fwSessionContainer.C_SESSION_CONTAINER,
					objfwSessionContainer);
		}

		
		return activeSession.get(session.getId());
	}

	protected boolean existsSession(HttpServletRequest request) {
		HttpSession session = request.getSession(true);
		return (!session.isNew());
	}

	protected void loadForm(HttpServletRequest request,
			HttpServletResponse response, String IdForm,
			fwSessionContainer objfwSessionContainer) throws Exception {

		// Busca el formularia a la pila
		JSPFormWrapper objFormWrapper = objfwSessionContainer.getStackForms().search(IdForm);
		if (objFormWrapper == null) {
			try {
				objFormWrapper = new JSPFormWrapper(IdForm);
			} catch (Exception e) {
				throw new ServletException(
						"No s'ha trobat la classe del formulari " + IdForm);
			}
			objfwSessionContainer.getStackForms().addForm(IdForm,objFormWrapper);
			objFormWrapper.getFormulariClass().addFilterListener(this);
			objFormWrapper.getFormulariClass().setfwSessionContainer(objfwSessionContainer);
			objfwSessionContainer.setCurrentForm(objFormWrapper);
			objfwSessionContainer.setCurrentHttpRequest(request);
			objfwSessionContainer.setCurrentHttpResponse(response);

		} 

		objFormWrapper.getFormulariClass().setStateForm(fwSessionContainer.C_FORM_LOAD);
		RequestDispatcher rd = request.getRequestDispatcher(objfwSessionContainer.getNextPage());
		rd.include(request, response);
		objFormWrapper.getFormulariClass().setStateForm(fwSessionContainer.C_FORM_LOADED);
	}

	public void DoNavigation(fwSessionContainer objfwSessionContainer, String Page)
			throws IOException, ServletException {

		objfwSessionContainer.setNextPage(Page);
		
		doInitForm(objfwSessionContainer.getCurrentHttpRequest(),
				objfwSessionContainer.getCurrentHttpResponse(),
				objfwSessionContainer, objfwSessionContainer.getNextPage());
	}
	
	
	private static String DivMessage(String msg){
		StringBuilder strMessage=new StringBuilder(); 
		
		strMessage.append("<div align=center>");
		strMessage.append(msg);
		strMessage.append("</div>");
		return strMessage.toString();
	}
}
