package fw.faces;

import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Enumeration;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.jsp.JspException;

import fw.taglib.UIComponent;

public abstract class AbstractForm {
	
	protected  Map<String, UIComponent> UIComponentes = new HashMap<String, UIComponent>();
	private String MyJSPPage;

	private int stateForm= fwSessionContainer.C_FORM_LOAD;
	protected fwSessionContainer objfwSessionContainer;
	protected boolean postBack=false;
	
	List<INavigateListener> listeners = new ArrayList<INavigateListener>();
 
    public void addFilterListener(INavigateListener toAdd) {
        listeners.add(toAdd);
    }
    
    public String createServerAction(String action, String serverFunction){
    	return action + "=\"jscript:sendAction('" + serverFunction + "', this)\"";
    }
    
    public void Navigate(String nextPage) throws IOException, ServletException {
      
        // Notify everybody that may be interested.
        for (INavigateListener hl : listeners)
            hl.DoNavigation(objfwSessionContainer, nextPage);
    }

    public void msgBox(String msg) throws IOException, ServletException {
        
    	objfwSessionContainer.setbMessage(true);
    	objfwSessionContainer.setUserMessage(msg);
		
    }

        
	public void addComponent(String key, UIComponent value ) throws JspException{
		key=key.toLowerCase();
		if (UIComponentes.containsKey(key))
			throw new JspException("La Clau " + key + " ja existeix al formulari ");
		UIComponentes.put(key, value);
	}
	
	public void addEvent(String key,UIComponent value ){		
		UIComponentes.put(key, value);
	}
	
	
	public Map<String, UIComponent> getUIComponentes() {
		return UIComponentes;
	}
	
	public String getMyJSPPage() {
		return MyJSPPage;
	}
	public void setMyJSPPage(String myJSPPage) {
		MyJSPPage = myJSPPage;
	}
	
	public UIComponent getComponentByName(String strName){
		return UIComponentes.get(strName.toLowerCase());
	} 
	
	public boolean ContainsComponent(String strName){
		return UIComponentes.get(strName.toLowerCase())!=null;
	} 
	
	public void setfwSessionContainer(fwSessionContainer objfwSessionContainer){
		this.objfwSessionContainer=objfwSessionContainer;
		
	}
	public int getStateForm() {
		return stateForm;
	}
	public void setStateForm(int stateForm) {
		this.stateForm = stateForm;
	}
	
	public boolean isPostBack(){
		return postBack;
	}
	
	public void setPostBack(boolean value){
		postBack=value;
	}
	
	public String ComponentToString(){		

		String  Valor="this.hashCode(): " + this.hashCode() + " ";
		
		this.hashCode();
		
		Iterator it = UIComponentes.entrySet().iterator();
		while (it.hasNext()) {
			Map.Entry e = (Map.Entry) it.next();
			UIComponent Component = (UIComponent) e.getValue();
			Valor=Valor.concat((String) e.getKey() + ": " +  Component.toString() + " \n ");
		}
		return Valor;
	}
	
	
	
}
