package fw.faces;

import java.io.IOException;
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import java.util.Enumeration;
import java.util.List;

import javax.servlet.ServletException;
import javax.servlet.ServletRequest;
import javax.servlet.ServletResponse;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.jsp.JspException;

import fw.taglib.UIComponent;

public class JSPFormWrapper {

	private String formID = "";
	private String classPath;
	private AbstractForm FormulariClass;
	private fwSessionContainer objfwSessionContainer;

	public JSPFormWrapper(String formID) throws Exception {

		this.formID = formID;
		setClassPath(standariceURL(formID));
		Instanciate();

	}

	private String standariceURL(String formName) {

		formName = formName.replace(".jsp", "");

		if (formName.startsWith("."))
			formName = formName.replaceFirst(".", "");
		if (formName.startsWith(".."))
			formName = formName.replaceFirst("..", "");
		if (formName.startsWith("/"))
			formName = formName.replaceFirst("/", "");

		formName = formName.replace("/", ".");

		return formName;
	}

	private void Instanciate() throws Exception {

		try {
			//classPath="main.menu";
			System.out.println("Instacion class: " + classPath);
			Class obj = Class.forName(classPath);
			FormulariClass = (AbstractForm) obj.newInstance();
			FormulariClass.setMyJSPPage(formID);

		} catch (Throwable e) {
			throw e;
		}
	}

	public void PreProcesPeticio(ServletRequest SerRequest,
			ServletResponse SerResponse, stackForms objStackForms)
			throws Exception {
		mutableString sbAction = new mutableString("PreProcesPeticio"); // Objecte
																		// per
																		// salvar
																		// el
																		// Keysensitive

		if (existsMethod(FormulariClass.getClass().getMethods(), sbAction)) {
			Method objMethod = FormulariClass.getClass().getMethod(
					sbAction.str, HttpServletRequest.class, HttpServletResponse.class,
					stackForms.class);

			if (objMethod != null)
				objMethod.invoke(FormulariClass, SerRequest, SerResponse,
						objStackForms);
		}
	}

	public void PostProcessForm(ServletRequest SerRequest,
			ServletResponse SerResponse, stackForms objStackForms)
			throws Exception {
		mutableString sbAction = new mutableString("PostProcessForm"); // Objecte
																		// per
																		// salvar
																		// el
																		// Keysensitive

		if (existsMethod(FormulariClass.getClass().getMethods(), sbAction)) {
			Method objMethod = FormulariClass.getClass().getMethod(
					sbAction.str, HttpServletRequest.class, HttpServletResponse.class,
					stackForms.class);

			if (objMethod != null)
				objMethod.invoke(FormulariClass, SerRequest, SerResponse,
						objStackForms);
		}
	}

	public void ProcessAction(ServletRequest SerRequest,
			ServletResponse SerResponse, stackForms objStackForms,
			String strAction, String IdSender) throws NoSuchMethodException,
			SecurityException, IllegalAccessException,
			IllegalArgumentException, InvocationTargetException {
		mutableString sbAction = new mutableString(strAction); // Objecte per
																// salvar el
																// Keysensitive

		if (existsMethod(FormulariClass.getClass().getMethods(), sbAction)) {
			UIComponent Sender = FormulariClass.getComponentByName(IdSender);

			Method objMethod;

			objMethod = FormulariClass.getClass().getMethod(sbAction.str,
					HttpServletRequest.class, HttpServletResponse.class,
					stackForms.class, UIComponent.class);

			if (objMethod != null)
				objMethod.invoke(FormulariClass, SerRequest, SerResponse,
						objStackForms, Sender);

		}
	}

	public boolean existsMethod(Method[] lstMethod, mutableString sbAction) {
		boolean value = false;
		String name = sbAction.str;

		for (int i = 0; i < lstMethod.length; i++) {
			if (lstMethod[i].getName().toLowerCase().equals(name.toLowerCase())) {
				sbAction.str = lstMethod[i].getName();
				value = true;
				return value;
			}

		}
		return value;

	}

	public void setParameter(UIComponent Component, String name, String value)
			throws Exception {
		try {
			Method lstMethod[] = Component.getClass().getMethods();
			Method objMethod;

			for (int i = 0; i < lstMethod.length; i++) {
				objMethod = lstMethod[i];
				if (objMethod.getName().compareToIgnoreCase(name) == 0) {
					objMethod.invoke(Component, value);
					i = lstMethod.length + 1;
				}
			}

		} catch (SecurityException e) {
			throw new JspException("Error de seguretat " + e.getMessage());
		} catch (Exception e) {
			throw new JspException("Error " + e.getMessage());
		}
	}

	public void procesPostback(HttpServletRequest httpRequest) throws Exception {
		Enumeration Enum = httpRequest.getParameterNames();
		String methodName;
		String[] value;
		String UIname;

		while (Enum.hasMoreElements()) {
			UIname = (String) Enum.nextElement();
			UIComponent UIComponentes = FormulariClass
					.getComponentByName(UIname);

			if (UIComponentes != null) {
				value = httpRequest.getParameterValues(UIname);
				methodName = UIComponentes.getPostbackConserveMethod();
				for (int i = 0; i < value.length; i++)
					setParameter(UIComponentes, methodName, value[i]);
			}
		}

	}

	public String getFormID() {
		return formID;
	}

	public void setFormID(String formID) {
		this.formID = formID;
	}

	public String getClassPath() {
		return classPath;
	}

	public void setClassPath(String classPath) {
		this.classPath = classPath;
	}

	public AbstractForm getFormulariClass() {
		return FormulariClass;
	}

	public void setFormulariJSP(AbstractForm FormulariClass) {
		this.FormulariClass = FormulariClass;
	}

	private class mutableString {
		public mutableString(String value) {
			str = value;
		}

		public String str = "";
	}

}
