package fw.taglib;

import java.util.Iterator;
import java.util.Map;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;
import javax.servlet.jsp.JspException;
import javax.servlet.jsp.PageContext;
import javax.servlet.jsp.tagext.BodyTagSupport;
import javax.servlet.jsp.tagext.DynamicAttributes;
import javax.servlet.jsp.tagext.Tag;


import fw.faces.AbstractForm;
import fw.faces.JSPFormWrapper;
import fw.faces.fwSessionContainer;


public abstract class AbstractTag extends BodyTagSupport implements DynamicAttributes, ITag {

	/**
	 *   
	 */
	private static final long serialVersionUID = 2113902284736541406L;
	// dynamic attributes.
	protected UIComponent Component;
	protected JSPFormWrapper objFormWrapper;
	protected AbstractForm FormulariClass;
	protected String fw_name = null;
	protected String NameAtt = "name";
	
	
	
	public void setPageContext(PageContext pageContext) {
		super.setPageContext(pageContext);
		// recuperamos la session y buscamo el form al que pertenece
		HttpSession session = ((HttpServletRequest) pageContext.getRequest()).getSession();
		fwSessionContainer objfwSessionContainer = (fwSessionContainer) session.getAttribute(fwSessionContainer.C_SESSION_CONTAINER);
		objFormWrapper = objfwSessionContainer.getCurrentFormWrapper();
		FormulariClass = objFormWrapper.getFormulariClass();
		
		//System.out.println("------------------------------ setPageContext /NAME: " + fw_name + " / " + getId());
		if (FormulariClass.getStateForm() == fwSessionContainer.C_FORM_LOAD) {
			Component=Instaciate();
		}else{
			Component=FormulariClass.getComponentByName(fw_name);
		}
	}

	public int doEndTag() throws JspException {
	
		
		if (FormulariClass.getStateForm() == fwSessionContainer.C_FORM_LOAD) {
			Iterator it = Component.getDynamicEnvents().entrySet().iterator();
			while (it.hasNext()) {
				Map.Entry e = (Map.Entry) it.next();
				setComponenteAtribute((String) e.getKey(),
						(String) e.getValue());
			}

			it = Component.getDynamicAttributes().entrySet().iterator();
			String attname;
			while (it.hasNext()) {
				Map.Entry e = (Map.Entry) it.next();
				attname = (String) e.getKey();
				
				if (attname.compareToIgnoreCase(NameAtt) == 0) {
					fw_name = (String) e.getValue();
				}
				setComponenteAtribute(attname, (String) e.getValue());
			}

			if (fw_name==null)
				throw new JspException("El component ha de tindre un attribut name");

			FormulariClass.addComponent(fw_name, Component);
			setId(fw_name);
			
		}
		//System.out.println("------------------------------ doEndTag "	+ FormulariClass.ComponentToString());
		
		return EVAL_PAGE;
	}

	@Override
	public void setDynamicAttribute(String uri, String localName, Object value)
			throws JspException {
		//System.out.println("Anado atribute " + uri + " - " + localName + "/" + value);
		String strValue = String.valueOf(value).toLowerCase();
		String strName= String.valueOf(localName).toLowerCase();
		if(NameAtt.equals(strName)){
			fw_name=strValue;
			setId(strValue);
		}
		// setComponenteAtribute(localName,(String)value);
		if (FormulariClass.getStateForm() == fwSessionContainer.C_FORM_LOAD) {
			if (UIComponent.isEvent(localName)) {
				Component.addEvent(localName.toLowerCase(), strValue);
			} else {
				Component.addAttribute(localName.toLowerCase(),strValue);
			}
		}
					
	}

	public String getHTMLEvents() {
		String strEvents = "";
		Iterator it;
		
		
		if (FormulariClass.getStateForm() == fwSessionContainer.C_FORM_LOAD)
			it = Component.getDynamicEnvents().entrySet().iterator();
		else
			it = FormulariClass.getComponentByName(getId()).getDynamicEnvents().entrySet().iterator();
		
		while (it.hasNext()) {
			Map.Entry e = (Map.Entry) it.next();
			strEvents = strEvents.concat(" " + e.getKey()
					+ "=\"jscript:sendAction('" + e.getValue() + "', this)\" ");
		}
		return strEvents;
	}

	public String getHTMLAtributes() {
		String strEvents = "";
		Iterator it;
		
		
		
		if (FormulariClass.getStateForm() == fwSessionContainer.C_FORM_LOAD)
			it = Component.getDynamicAttributes().entrySet().iterator();
		else
			it = FormulariClass.getComponentByName(getId()).getDynamicAttributes().entrySet().iterator();
		
		while (it.hasNext()) {
			Map.Entry e = (Map.Entry) it.next();
			strEvents = strEvents.concat(" " + e.getKey() + "=\""
					+ e.getValue() + "\" ");
		}

		
		return strEvents;
	}

	private void setComponenteAtribute(String strMethod, String value)
			throws JspException {
		try {

			objFormWrapper.setParameter(Component, "set" + strMethod, value);

		} catch (NoSuchMethodException e) {
			throw new JspException("L'atribut set" + strMethod + " no existeix");
		} catch (SecurityException e) {
			throw new JspException("Error de seguretat " + e.getMessage());
		} catch (Exception e) {
			throw new JspException("Error " + strMethod + " - "
					+ e.getMessage());
		}
	}
	
	public UIComponent getComponent(){
		return this.Component;
	}

}
