package fw.taglib;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Hashtable;
import java.util.Iterator;
import java.util.Map;

public abstract class UIComponent implements IUIComponent {
	private Map<String, Object> dynamicAttributes = new HashMap<String, Object>();
	private Map<String, Object> dynamicEnvents = new HashMap<String, Object>();
	private Hashtable<String, String> lstEvents = new Hashtable<String, String>();
	
	protected String id;
	protected String cssClass;
	protected String cssStyle;
	protected String cssErrorClass;
	protected String cssErrorStyle;
	protected String disabled;
	protected String label;
	protected String labelPosition;
	protected String labelSeparator;
	protected String requiredPosition;
	protected String errorPosition;
	protected String name;
	protected String requiredLabel;
	protected String tabindex;
	protected String value;
	protected String title;

	// HTML scripting events attributes
	protected String onclick;
	protected String ondblclick;
	protected String onmousedown;
	protected String onmouseup;
	protected String onmouseover;
	protected String onmousemove;
	protected String onmouseout;
	protected String onfocus;
	protected String onblur;
	protected String onkeypress;
	protected String onkeydown;
	protected String onkeyup;
	protected String onselect;
	protected String onchange;
	
	public static boolean isEvent(String attibute){
		boolean result=false;
		String eventString="|onclick|ondblclick|onmousedown|onmouseup|onmouseover|onmousemove|onmouseout|onfocus|onblur|onkeypress|onkeydown|onkeyup|onselect|onchange|";
		
		if (attibute.startsWith("fw_") ){
			attibute=attibute.replace("fw_", "");
			if (eventString.contains("|" + attibute.toLowerCase() + "|"))
				result=true;
		}
		return result;
	}
	
	
	public Map<String, Object> getDynamicAttributes(){
		return dynamicAttributes;
	}
	
	public Map<String, Object> getDynamicEnvents(){
		return dynamicEnvents;
	}
	
	public void addEvent(String attibute, String value){
		String name=attibute;
		if (attibute.startsWith("fw_") ){
			attibute=attibute.replace("fw_", "");
			dynamicEnvents.put(attibute, value);
			lstEvents.put(attibute, name);
		}else{
			String eve=(String)lstEvents.get(attibute); //ja eixteix venim d'un postback
			if(eve==null)
				dynamicAttributes.put(attibute, value);
			
		}		
		
	}
	
	public void addAttribute(String attibute, String value){
		dynamicAttributes.put(attibute, value);
	}
	

	//atributs
	public String getId() {
		return id;
	}
	public void setId(String id) {
		this.id = id;
		dynamicAttributes.put("id", id);
	}
	public String getCssClass() {
		return cssClass;
	}
	public void setCssClass(String cssClass) {
		this.cssClass = cssClass;
		dynamicAttributes.put("cssClass", cssClass);
	}
	public String getCssStyle() {
		return cssStyle;
	}
	public void setCssStyle(String cssStyle) {
		this.cssStyle = cssStyle;
		dynamicAttributes.put("cssStyle", cssStyle);
	}
	public String getCssErrorClass() {
		return cssErrorClass;
	}
	public void setCssErrorClass(String cssErrorClass) {
		this.cssErrorClass = cssErrorClass;
		dynamicAttributes.put("cssErrorClass", cssErrorClass);
	}
	public String getCssErrorStyle() {
		return cssErrorStyle;
	}
	public void setCssErrorStyle(String cssErrorStyle) {
		this.cssErrorStyle = cssErrorStyle;
		dynamicAttributes.put("cssErrorStyle", cssErrorStyle);
	}
	public String getDisabled() {
		return disabled;
	}
	public void setDisabled(boolean b) {
		
		if(b){
			dynamicAttributes.put("disabled", "disabled");
			this.disabled = "disabled";
		}
		else{
			dynamicAttributes.remove("disabled");
			this.disabled = "";
		}
	}
	public String getLabel() {
		return label;
	}
	public void setLabel(String label) {
		this.label = label;
		dynamicAttributes.put("label", label);
	}
	public String getLabelPosition() {
		return labelPosition;
	}
	public void setLabelPosition(String labelPosition) {
		this.labelPosition = labelPosition;
		dynamicAttributes.put("labelPosition", labelPosition);
	}
	public String getLabelSeparator() {
		return labelSeparator;
	}
	public void setLabelSeparator(String labelSeparator) {
		this.labelSeparator = labelSeparator;
		dynamicAttributes.put("labelSeparator", labelSeparator);
	}
	public String getRequiredPosition() {
		return requiredPosition;
	}
	public void setRequiredPosition(String requiredPosition) {
		this.requiredPosition = requiredPosition;
		dynamicAttributes.put("requiredPosition", requiredPosition);
	}
	public String getErrorPosition() {
		return errorPosition;
	}
	public void setErrorPosition(String errorPosition) {
		this.errorPosition = errorPosition;
		dynamicAttributes.put("errorPosition", errorPosition);
	}
	public String getName() {
		return name;
	}
	public void setName(String name) {
		this.name = name;
		dynamicAttributes.put("name", name);
	}
	public String getRequiredLabel() {
		return requiredLabel;
	}
	public void setRequiredLabel(String requiredLabel) {
		this.requiredLabel = requiredLabel;
		dynamicAttributes.put("requiredLabel", requiredLabel);
	}
	public String getTabindex() {
		return tabindex;
	}
	public void setTabindex(String tabindex) {
		this.tabindex = tabindex;
		dynamicAttributes.put("tabindex", tabindex);
	}
	public String getValue() {
		return value;
	}
	public void setValue(String value) {
		this.value = value;
		dynamicAttributes.put("value", value);
	}
	public String getTitle() {
		return title;
	}
	public void setTitle(String title) {
		this.title = title;
		dynamicAttributes.put("title", title);
	}
	
	
	//EVENTOS 
	public String getOnclick() {
		return onclick;
	}
	public void setOnclick(String onclick) {
		this.onclick = onclick;
		addEvent("onclick", onclick);
	}
	public String getOndblclick() {
		return ondblclick;
	}
	public void setOndblclick(String ondblclick) {
		this.ondblclick = ondblclick;
		addEvent("ondblclick", ondblclick);
	}
	public String getOnmousedown() {
		return onmousedown;
	}
	public void setOnmousedown(String onmousedown) {
		this.onmousedown = onmousedown;
		addEvent("onmousedown", onmousedown);
	}
	public String getOnmouseup() {
		return onmouseup;
	}
	public void setOnmouseup(String onmouseup) {
		this.onmouseup = onmouseup;
		addEvent("onmouseup", onmouseup);
	}
	public String getOnmouseover() {
		return onmouseover;
	}
	public void setOnmouseover(String onmouseover) {
		this.onmouseover = onmouseover;
		addEvent("onmouseover", onmouseover);
	}
	public String getOnmousemove() {
		return onmousemove;
	}
	public void setOnmousemove(String onmousemove) {
		this.onmousemove = onmousemove;
		addEvent("onmousemove", onmousemove);
	}
	public String getOnmouseout() {
		return onmouseout;
	}
	public void setOnmouseout(String onmouseout) {
		this.onmouseout = onmouseout;
		addEvent("onmouseout", onmouseout);
	}
	public String getOnfocus() {
		return onfocus;
	}
	public void setOnfocus(String onfocus) {
		this.onfocus = onfocus;
		addEvent("onfocus", onfocus);
	}
	public String getOnblur() {
		return onblur;
	}
	public void setOnblur(String onblur) {
		this.onblur = onblur;
		addEvent("onblur", onblur);
	}
	public String getOnkeypress() {
		return onkeypress;
	}
	public void setOnkeypress(String onkeypress) {
		this.onkeypress = onkeypress;
		addEvent("onkeypress", onkeypress);
	}
	public String getOnkeydown() {
		return onkeydown;
	}
	public void setOnkeydown(String onkeydown) {
		this.onkeydown = onkeydown;
		addEvent("onkeydown", onkeydown);
	}
	public String getOnkeyup() {
		return onkeyup;
	}
	public void setOnkeyup(String onkeyup) {
		this.onkeyup = onkeyup;
		addEvent("onkeyup", onkeyup);
	}
	public String getOnselect() {
		return onselect;
	}
	public void setOnselect(String onselect) {
		this.onselect = onselect;
		addEvent("onselect", onselect);
	}
	public String getOnchange() {
		return onchange;
	}
	public void setOnchange(String onchange) {
		this.onchange = onchange;
		addEvent("onchange", onchange);
	}

	public String toString(){
		
		String  Valor="\n HasCode: " + this.hashCode() + " " ;
		
		Iterator it = getDynamicEnvents().entrySet().iterator();
		while (it.hasNext()) {
			Map.Entry e = (Map.Entry) it.next();
			Valor=Valor.concat((String) e.getKey() + ": " +  (String) e.getValue() + ", ");
		}

		it = getDynamicAttributes().entrySet().iterator();
		while (it.hasNext()) {
			Map.Entry e = (Map.Entry) it.next();
			Valor=Valor.concat((String) e.getKey() + ": " +  (String) e.getValue() + ", ");
		}
		return Valor;
	}
}
